arrocco(bianco,Scacchiera,torre,(8,1),(XT,YT),_,(X,Y),(XR,YR)):-
  merge_pieces(Scacchiera,U),
  pieces(bianco,Scacchiera,Pezzi,Altri),
  re(Pezzi,(X,Y)),
  controlla_re(bianco,X,Y),
  \+ scacco(nero,Scacchiera,Altri,(X,Y)),
  remove_piece((X,Y),Pezzi,NewPezzi),
  insert_piece(re,(6,1),NewPezzi,NewPezzi1),
  \+ scacco(nero,(NewPezzi1,Altri),Altri,(6,1)),
  remove_piece((6,1),NewPezzi1,NewPezzi),
  insert_piece(re,(7,1),NewPezzi,NewP1),
  \+ scacco(nero,(NewP1,Altri),Altri,(7,1)),
  arroccocorto(bianco,U,(8,1),(XT,YT),(XR,YR)).

arrocco(bianco,Scacchiera,torre,(1,1),(XT,YT),_,(X,Y),(XR,YR)):-
  merge_pieces(Scacchiera,U),
  pieces(bianco,Scacchiera,Pezzi,Altri),
  re(Pezzi,(X,Y)),
  controlla_re(bianco,X,Y),
  \+ scacco(nero,Scacchiera,Altri,(X,Y)),
  remove_piece((X,Y),Pezzi,NewPezzi),
  insert_piece(re,(4,1),NewPezzi,NewPezzi1),
  \+ scacco(nero,(NewPezzi1,Altri),Altri,(4,1)),
  remove_piece((4,1),NewPezzi1,NewPezzi),
  insert_piece(re,(3,1),NewPezzi,NewP1),
  \+ scacco(nero,(NewP1,Altri),Altri,(3,1)),
  arroccolungo(bianco,U,(1,1),(XT,YT),(XR,YR)).

arrocco(nero,Scacchiera,torre,(8,8),(XT,YT),_,(X,Y),(XR,YR)):-
  merge_pieces(Scacchiera,U),
  pieces(nero,Scacchiera,Pezzi,Altri),
  re(Pezzi,(X,Y)),
  controlla_re(nero,X,Y),
  \+ scacco(bianco,Scacchiera,Altri,(X,Y)),
  remove_piece((X,Y),Pezzi,NewPezzi),
  insert_piece(re,(6,8),NewPezzi,NewPezzi1),
    \+ scacco(bianco,(NewPezzi1,Altri),Altri,(6,8)),
   remove_piece((6,8),NewPezzi1,NewPezzi),
   insert_piece(re,(7,8),NewPezzi,NewP1),
   \+ scacco(bianco,(NewP1,Altri),Altri,(7,8)),
   arroccocorto(nero,U,(8,8),(XT,YT),(XR,YR)).

arrocco(nero,Scacchiera,torre,(1,8),(XT,YT),_,(X,Y),(XR,YR)):-
  merge_pieces(Scacchiera,U),
  pieces(nero,Scacchiera,Pezzi,Altri),
  re(Pezzi,(X,Y)),
  controlla_re(nero,X,Y),
  \+ scacco(bianco,Scacchiera,Altri,(X,Y)),
  remove_piece((X,Y),Pezzi,NewPezzi),
  insert_piece(re,(4,8),NewPezzi,NewPezzi1),
  \+ scacco(bianco,(NewPezzi1,Altri),Altri,(4,8)),
  remove_piece((4,8),NewPezzi1,NewPezzi),
  insert_piece(re,(3,8),NewPezzi,NewP1),
  \+ scacco(bianco,(NewP1,Altri),Altri,(3,8)),
  arroccolungo(nero,U,(1,8),(XT,YT),(XR,YR)).

arroccocorto(bianco,U,(8,1),(XT,YT),(XR,YR)):-
  \+ memberchk(( _,6,1),U),
  \+ memberchk(( _,7,1),U),
  XR is 7,YR is 1,
  XT is 6,YT is 1.

arroccocorto(nero,U,(8,8),(XT,YT),(XR,YR)):-
  \+ memberchk(( _,6,8),U),
  \+ memberchk(( _,7,8),U),
  XR is 7,YR is 8,
  XT is 6,YT is 8.

arroccolungo(bianco,U,(1,1),(XT,YT),(XR,YR)):-
  \+ memberchk((_,2,1),U),
  \+ memberchk((_,3,1),U),
  \+ memberchk((_,4,1),U),
  XR is 3,YR is 1,
  XT is 4,YT is 1.

arroccolungo(nero,U,(1,8),(XT,YT),(XR,YR)):-
  \+ memberchk((_,2,8),U),
  \+ memberchk((_,3,8),U),
  \+ memberchk((_,4,8),U),
  XR is 3,YR is 8,
  XT is 4,YT is 8.

%%%%%%%%%
% UTILS %
%%%%%%%%%

controlla_re(bianco,X,Y):-
  X = 5, Y = 1.
controlla_re(nero,X,Y):-
  X = 5, Y = 8.
 










