unit MvList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

type
  TMvListFrm = class(TForm)
    ListView1: TListView;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AggiungiRiga(num: integer; tipo: char; giocatore: integer;
                           mossa,valore: integer; tempo: string);
  end;

var
  MvListFrm: TMvListFrm;

implementation

uses Main, DebugView;

{$R *.dfm}

procedure TMvListFrm.AggiungiRiga(num: integer; tipo: char; giocatore,
  mossa, valore: integer; tempo: string);
var
  ListItem: TListItem;
begin
  with ListView1 do
  begin
    ListItem := Items.Add;
    ListItem.Caption := IntToStr(num);
    ListItem.SubItems.Add(tipo);
    ListItem.SubItems.Add(IntToStr(giocatore));
    ListItem.SubItems.Add(IntToStr(mossa));
    if tipo='C' then
      ListItem.SubItems.Add(IntToStr(valore))
    else
      ListItem.SubItems.Add(' ');
    ListItem.SubItems.Add(tempo);
  end
end;

procedure TMvListFrm.FormShow(Sender: TObject);
begin
  Height := MainFrm.Height;
  Top := MainFrm.Top;
  Left := MainFrm.Left + MainFrm.Width;
  if DebugFrm.Visible then Left := Left + DebugFrm.Width;
end;

end.
