%%%%%%%%%%%%%%%%%%%%%
% FUNZIONI DI DEBUG %
%%%%%%%%%%%%%%%%%%%%%

% open_debug(+Mode,+FileName,-Dbg)
open_debug(none,_,nil) :- !.
open_debug(normal,FileName,(normal,Stream)) :-
  !, open(FileName,write,Stream).
open_debug(extra,FileName,(extra,Stream)) :-
  !, open(FileName,write,Stream).

% close_debug(+Dbg)
close_debug(nil) :- !.
close_debug((_,Stream)) :- close(Stream).

% writeDebug(+Dbg,+String,+Parameters)
writeDebug(nil,_,_) :- !.
writeDebug((normal,Stream),S,P) :- !, scriviDebug(Stream,S,P).
writeDebug((extra,Stream),S,P) :- !, scriviDebug(Stream,S,P).

% extraDebug(+Dbg,+String,+Parameters)
extraDebug(nil,_,_) :- !.
extraDebug((normal,_),_,_) :- !.
extraDebug((extra,Stream),S,P) :- scriviDebug(Stream,S,P).

scriviDebug(Stream,S,P) :-
  writef(S,P),nl, flush_output,
  scrivi_su_file(Stream,S,P).
scrivi_su_file(nil,_,_) :- !.
scrivi_su_file(Stream,S,P) :-
  swritef(String,S,P),
  write(Stream,String),nl(Stream),
  flush_output(Stream).








