%%%%%%%%%%%%%%%%%
% MOSSA CAVALLO %
%%%%%%%%%%%%%%%%%

mossa_cavallo(Position,(X0,Y0),(X,Y)):-
        mosse_cav((X0,Y0),(X,Y)),
	mossaC(Position,X,Y).

mossaC(Position,X,Y):-	
	(X>=1),(X=<8),(Y>=1),(Y =< 8),
	free(Position,(X,Y)).

%%%%%%%%%%%%%%%%%
% PRESA CAVALLO %
%%%%%%%%%%%%%%%%%

presa_cavallo(Colore,Position,(X0,Y0),(X,Y),Idx,(X,Y)):-
        mosse_cav((X0,Y0),(X,Y)),
        pieces(Colore,Position,_,Pezzi),
	presaC(Pezzi,Idx,X,Y).

presaC(Pezzi,Idx,X,Y):-	
        (X>=1),(X=<8),(Y>=1),(Y =< 8),
	free(Pezzi,Idx,(X,Y)).

%%%%%%%%%%%%%%%%%
% CODICE COMUNE %
%%%%%%%%%%%%%%%%%

mosse_cav((X0,Y0),(X,Y)) :-
%	(X0>=1),(X0=<8),(Y0>=1),(Y0 =< 8),
        X is X0-1, Y is Y0-2;
        X is X0-1, Y is Y0+2;
        X is X0-2, Y is Y0-1;
        X is X0-2, Y is Y0+1;
        X is X0+1, Y is Y0-2;
        X is X0+1, Y is Y0+2;
        X is X0+2, Y is Y0-1;
        X is X0+2, Y is Y0+1,
        \+ equal_coords((X0,Y0),(X,Y)).
       







