mossa_pedone(bianco,Position,(X0,Y0),(X,Y)) :-
	(Y0 < 7), 
        X is X0, Y is Y0+1, 
	free(Position,(X,Y));
	(Y0 = 2),
	X is X0, Y is Y0+2,
	Y1 is Y0+1,
        free(Position,(X,Y1)),
	free(Position,(X,Y)).
  
mossa_pedone(nero,Position,(X0,Y0),(X,Y)) :-
        (Y0 >2), 
	X is X0, Y is Y0-1, 
	free(Position,(X,Y));
        (Y0 = 7),
	X is X0, Y is Y0-2,
	Y1 is Y0-1,
	free(Position,(X,Y1)),
	free(Position,(X,Y)).

presa_pedone(bianco,Position,(X0,Y0),(X,Y),Idx,(X,Y)) :-
	opponent(bianco,Avversario),pieces(Avversario,Position,Pezzi,_),
	(Y0 < 7), 
	(X is X0-1, Y is Y0+1) ,
	memberchk((Idx,X,Y),Pezzi).
%	free(Pezzi,(Idx,X,Y)).
	
presa_pedone(bianco,Position,(X0,Y0),(X,Y),Idx,(X,Y)) :-
	opponent(bianco,Avversario),pieces(Avversario,Position,Pezzi,_),
	(Y0 < 7), 
	(X is X0+1, Y is Y0+1),         
	memberchk((Idx,X,Y),Pezzi).
       % free(Pezzi,(Idx,X,Y)).
	 	
presa_pedone(nero,Position,(X0,Y0),(X,Y),Idx,(X,Y)) :-
	opponent(nero,Avversario),pieces(Avversario,Position,Pezzi,_),
	(Y0 > 2), 
	(X is X0-1, Y is Y0-1), 
	memberchk((Idx,X,Y),Pezzi).
%	free(Pezzi,(Idx,X,Y)).


presa_pedone(nero,Position,(X0,Y0),(X,Y),Idx,(X,Y)) :-
	opponent(nero,Avversario),pieces(Avversario,Position,Pezzi,_),
	(Y0 > 2),  
	(X is X0+1, Y is Y0-1), 
	memberchk((Idx,X,Y),Pezzi).
%	free(Pezzi,(Idx,X,Y)).


% **********
presa_pedonePas(bianco,Position,(X0,Y0),(Xf,Yf),Idx,(X,Y0)) :-
         opponent(bianco,Avversario),pieces(Avversario,Position,Pezzi,_),
	 (Y0=5),
	  X is X0+1,
	  memberchk((Idx,X,Y0),Pezzi),
	  Idx = pedone,
	  Xf is X,
	  Yf is Y0+1 .
	 
presa_pedonePas(bianco,Position,(X0,Y0),(Xf,Yf),Idx,(X,Y0)) :-
         opponent(bianco,Avversario),pieces(Avversario,Position,Pezzi,_),
	 (Y0=5),
	  X is X0-1,
	  memberchk((Idx,X,Y0),Pezzi),
	  Idx = pedone,
	  Xf is X,
	  Yf is Y0+1.
	 

presa_pedonePas(nero,Position,(X0,Y0),(Xf,Yf),Idx,(X,Y0)) :-
         opponent(nero,Avversario),pieces(Avversario,Position,Pezzi,_),
	 (Y0=4),
	  X is X0-1,
	  memberchk((Idx,X,Y0),Pezzi),
	  Idx = pedone,
	  Xf is X,
	  Yf is Y0-1 .
	 
presa_pedonePas(nero,Position,(X0,Y0),(Xf,Yf),Idx,(X,Y0)) :-
         opponent(nero,Avversario),pieces(Avversario,Position,Pezzi,_),
	 (Y0=4),
	  X is X0+1,
	  memberchk((Idx,X,Y0),Pezzi),
	  Idx = pedone,
	  Xf is X,
	  Yf is Y0-1.
